live-build/helpers/lh_binary_usb-hdd

281 lines
5.8 KiB
Plaintext
Raw Normal View History

2007-09-23 08:04:46 +00:00
#!/bin/sh
2007-09-23 08:05:11 +00:00
# lh_binary_usb-hdd(1) - build binary usb-hdd image
# Copyright (C) 2006-2009 Daniel Baumann <daniel@debian.org>
2007-09-23 08:04:48 +00:00
#
# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
# This is free software, and you are welcome to redistribute it
# under certain conditions; see COPYING for details.
2007-09-23 08:04:46 +00:00
set -e
2007-09-23 08:05:11 +00:00
# Including common functions
2009-11-22 12:40:20 -01:00
. "${LH_BASE:-/usr/share/live-helper}"/live-helper.sh
2007-09-23 08:04:46 +00:00
2007-09-23 08:05:11 +00:00
# Setting static variables
DESCRIPTION="$(Echo 'build binary image')"
2007-09-23 08:04:48 +00:00
HELP=""
USAGE="${PROGRAM} [--force]"
Arguments "${@}"
2007-09-23 08:04:46 +00:00
# Reading configuration files
Read_conffiles config/all config/common config/bootstrap config/chroot config/binary config/source
2007-09-23 08:04:46 +00:00
Set_defaults
2008-06-20 00:31:21 +00:00
if ! In_list usb-hdd "${LH_BINARY_IMAGES}"
2007-09-23 08:05:11 +00:00
then
exit 0
fi
Echo_message "Begin building binary usb-hdd image..."
# Requiring stage file
Require_stagefile .stage/config .stage/bootstrap .stage/chroot_proc
2007-09-23 08:05:11 +00:00
# Checking stage file
Check_stagefile .stage/binary_usb-hdd
# Checking lock file
Check_lockfile .lock
# Creating lock file
Create_lockfile .lock
# Checking depends
Check_package chroot/sbin/mkdosfs dosfstools
2007-09-23 08:05:16 +00:00
Check_package chroot/usr/share/doc/mtools mtools
2007-09-23 08:05:11 +00:00
Check_package chroot/sbin/parted parted
if [ "${LH_ARCHITECTURE}" = "sparc" ]
then
case "${LH_BINARY_FILESYSTEM}" in
ext2|ext3)
Check_package chroot/sbin/mkfs.ext2 e2fsprogs
;;
*)
Echo_error "Sparc only supports booting from ext2, ext3 (or ufs)"
exit 1
;;
esac
fi
2007-09-23 08:05:17 +00:00
case "${LH_BOOTLOADER}" in
2007-09-23 08:05:11 +00:00
grub)
Check_package chroot/usr/sbin/grub grub
;;
syslinux)
Check_package chroot/usr/bin/syslinux syslinux
;;
esac
2007-09-23 08:05:15 +00:00
# Restoring cache
Restore_cache cache/packages_binary
2007-09-23 08:05:11 +00:00
# Installing depends
Install_package
# Remove old binary
if [ -f binary.img ]
then
rm -f binary.img
fi
# Enforce fat32 if we find individual files bigger than 2GB
if [ "${LH_BINARY_FILESYSTEM}" = "fat16" ] && [ -n "$(find binary -size +1999M)" ]
then
Echo_warning "FAT16 doesn't support files larger than 2GB, automatically enforcing FAT32."
LH_BINARY_FILESYSTEM="fat32"
export LH_BINARY_FILESYSTEM
fi
# Enforce fat32 if we have images in total bigger than 2GB
if [ "${LH_BINARY_FILESYSTEM}" = "fat16" ] && [ "$(du -s binary | awk '{ print $1 }')" -gt "1900000" ]
then
Echo_warning "FAT16 doesn't support partitions larger than 2GB, automatically enforcing FAT32"
LH_BINARY_FILESYSTEM="fat32"
export LH_BINARY_FILESYSTEM
fi
2007-09-23 08:05:11 +00:00
# Everything which comes here needs to be cleaned up,
DU_DIM="$(du -ms binary | cut -f1)"
REAL_DIM="$(Calculate_partition_size ${DU_DIM} ${LH_BINARY_FILESYSTEM})"
dd if=/dev/zero of=chroot/binary.img bs=1024k count=0 seek=${REAL_DIM}
FREELO="$(${LH_LOSETUP} -f)"
2007-09-23 08:05:11 +00:00
if [ ! -b chroot/${FREELO} ]
then
MAKEDEV="true"
mv chroot/dev chroot/dev.tmp
find /dev | cpio -dmpu chroot
fi
echo "!!! The following error/warning messages can be ignored !!!"
Losetup $FREELO chroot/binary.img 0
2007-09-23 08:05:11 +00:00
case "${LH_ARCHITECTURE}" in
sparc)
PARTITION_TABLE_TYPE="sun"
;;
*)
PARTITION_TABLE_TYPE="msdos"
;;
esac
2008-06-15 15:17:42 +00:00
case "${LH_BINARY_FILESYSTEM}" in
ext2|ext3)
PARTITION_TYPE="ext2"
2008-06-17 05:08:24 +00:00
;;
2008-06-15 15:17:42 +00:00
fat16|fat32)
PARTITION_TYPE="${LH_BINARY_FILESYSTEM}"
;;
*)
Echo_error "Unsupported binary filesystem %s" "${LH_BINARY_FILESYSTEM}"
2008-06-15 15:17:42 +00:00
exit 1
;;
esac
2007-09-23 08:05:17 +00:00
case "${LH_CHROOT_BUILD}" in
true)
Chroot chroot "parted -s ${FREELO} mklabel ${PARTITION_TABLE_TYPE}" || true
Chroot chroot "parted -s ${FREELO} mkpart primary ${PARTITION_TYPE} 0.0 100%" || true
Chroot chroot "parted -s ${FREELO} set 1 boot on" || true
Chroot chroot "parted -s ${FREELO} set 1 lba off" || true
2007-09-23 08:05:16 +00:00
2007-09-23 08:05:17 +00:00
if [ "${LH_BOOTLOADER}" = "syslinux" ]
2007-09-23 08:05:16 +00:00
then
dd if=chroot/usr/lib/syslinux/mbr.bin of=${FREELO} bs=440 count=1
2007-09-23 08:05:16 +00:00
fi
;;
false)
parted -s ${FREELO} mklabel ${PARTITION_TABLE_TYPE} || true
2008-11-11 01:06:53 -01:00
parted -s ${FREELO} mkpart primary ${PARTITION_TYPE} 0.0 100% || true
2007-09-23 08:05:16 +00:00
parted -s ${FREELO} set 1 boot on || true
parted -s ${FREELO} set 1 lba off || true
2007-09-23 08:05:17 +00:00
if [ "${LH_BOOTLOADER}" = "syslinux" ]
2007-09-23 08:05:16 +00:00
then
dd if=/usr/lib/syslinux/mbr.bin of=${FREELO} bs=440 count=1
2007-09-23 08:05:16 +00:00
fi
;;
esac
2007-09-23 08:05:11 +00:00
sleep 1
2007-09-23 08:05:11 +00:00
${LH_LOSETUP} -d ${FREELO}
FREELO="$(${LH_LOSETUP} -f)"
Losetup $FREELO chroot/binary.img 1
2007-09-23 08:05:16 +00:00
case "${LH_BINARY_FILESYSTEM}" in
ext2|ext3)
MKFS="${LH_BINARY_FILESYSTEM}"
MKFS_OPTIONS="-L DEBIAN_LIVE -m 0"
;;
fat16)
2008-06-17 05:08:24 +00:00
MKFS="vfat"
2008-06-15 15:25:34 +00:00
MKFS_OPTIONS="-F 16 -n DEBIAN_LIVE"
;;
fat32)
2008-06-17 05:08:24 +00:00
MKFS="vfat"
2008-06-15 15:25:34 +00:00
MKFS_OPTIONS="-F 32 -n DEBIAN_LIVE"
;;
esac
2007-09-23 08:05:17 +00:00
case "${LH_CHROOT_BUILD}" in
true)
Chroot chroot "mkfs.${MKFS} ${MKFS_OPTIONS} ${FREELO}"
2007-09-23 08:05:16 +00:00
;;
false)
2008-06-15 15:25:34 +00:00
mkfs.${MKFS} ${MKFS_OPTIONS} ${FREELO}
2007-09-23 08:05:16 +00:00
;;
esac
case "${LH_BINARY_FILESYSTEM}" in
fat*)
CP_OPTIONS="-L"
;;
esac
2007-09-23 08:05:12 +00:00
mkdir -p chroot/binary.tmp
${LH_ROOT_COMMAND} mount ${FREELO} chroot/binary.tmp
cp -r -T ${CP_OPTIONS} binary/ chroot/binary.tmp
2007-09-23 08:05:12 +00:00
FIXME()
{
2007-09-23 08:05:17 +00:00
if [ "${LH_BOOTLOADER}" = "grub" ]
2007-09-23 08:05:12 +00:00
then
cat > chroot/grub.sh << EOF
cd binary.tmp
grub --batch << EOM
find /live/vmlinuz
EOM
EOF
rootpartition="$(Chroot chroot 'sh grub.sh' 2>/dev/null | grep -A 1 'find /live/vmlinuz' | grep -v 'find /live/vmlinuz')"
usbdev="$(echo $rootpartition | sed -e 's|,[[:digit:]]||')"
2007-09-23 08:05:12 +00:00
echo "Root partition is $rootpartition, device is: $usbdev"
echo "WAITING..." && read WAIT
2007-09-23 08:05:12 +00:00
#cat > chroot/grub.sh << EOF
#grub --batch << EOM
#root $rootpartition
#setup $usbdev
#EOM
#EOF
#Chroot chroot "sh grub.sh"
2007-09-23 08:05:12 +00:00
rm -f chroot/grub.sh
fi
}
${LH_ROOT_COMMAND} umount chroot/binary.tmp
rmdir chroot/binary.tmp
2007-09-23 08:05:11 +00:00
2007-09-23 08:05:17 +00:00
if [ "${LH_BOOTLOADER}" = "syslinux" ]
2007-09-23 08:05:11 +00:00
then
2007-09-23 08:05:17 +00:00
case "${LH_CHROOT_BUILD}" in
true)
Chroot chroot "syslinux ${FREELO}"
2007-09-23 08:05:16 +00:00
;;
false)
2007-09-23 08:05:16 +00:00
syslinux ${FREELO}
;;
esac
2007-09-23 08:05:11 +00:00
fi
sleep 1
2007-09-23 08:05:11 +00:00
${LH_LOSETUP} -d ${FREELO}
echo "!!! The above error/warning messages can be ignored !!!"
if [ -n "${MAKEDEV}" ]
then
2007-09-23 08:05:13 +00:00
rm -rf chroot/dev
2007-09-23 08:05:11 +00:00
mv chroot/dev.tmp chroot/dev
fi
2007-09-23 08:05:12 +00:00
mv chroot/binary.img ./
2007-09-23 08:05:15 +00:00
# Saving cache
Save_cache cache/packages_binary
2007-09-23 08:05:11 +00:00
# Removing depends
Remove_package
# Creating stage file
Create_stagefile .stage/binary_usb-hdd